? src/backend/access/common/.deps
? src/backend/access/gist/.deps
? src/backend/access/hash/.deps
? src/backend/access/heap/.deps
? src/backend/access/index/.deps
? src/backend/access/nbtree/.deps
? src/backend/access/rtree/.deps
? src/backend/access/transam/.deps
? src/backend/bootstrap/.deps
? src/backend/catalog/.deps
? src/backend/catalog/pg_constraint.c
? src/backend/catalog/pg_depend.c
? src/backend/commands/.deps
? src/backend/executor/.deps
? src/backend/lib/.deps
? src/backend/libpq/.deps
? src/backend/main/.deps
? src/backend/nodes/.deps
? src/backend/optimizer/geqo/.deps
? src/backend/optimizer/path/.deps
? src/backend/optimizer/plan/.deps
? src/backend/optimizer/prep/.deps
? src/backend/optimizer/util/.deps
? src/backend/parser/.deps
? src/backend/port/.deps
? src/backend/postmaster/.deps
? src/backend/regex/.deps
? src/backend/rewrite/.deps
? src/backend/storage/buffer/.deps
? src/backend/storage/file/.deps
? src/backend/storage/freespace/.deps
? src/backend/storage/ipc/.deps
? src/backend/storage/large_object/.deps
? src/backend/storage/lmgr/.deps
? src/backend/storage/page/.deps
? src/backend/storage/smgr/.deps
? src/backend/tcop/.deps
? src/backend/utils/.deps
? src/backend/utils/adt/.deps
? src/backend/utils/cache/.deps
? src/backend/utils/error/.deps
? src/backend/utils/fmgr/.deps
? src/backend/utils/hash/.deps
? src/backend/utils/init/.deps
? src/backend/utils/mb/.deps
? src/backend/utils/misc/.deps
? src/backend/utils/mmgr/.deps
? src/backend/utils/sort/.deps
? src/backend/utils/time/.deps
? src/bin/pg_dump/.deps
? src/bin/pg_encoding/.deps
? src/bin/pg_id/.deps
? src/bin/pg_passwd/pg_passwd
? src/bin/psql/.deps
? src/include/catalog/pg_constraint.h
? src/include/catalog/pg_depend.h
? src/interfaces/ecpg/lib/.deps
? src/interfaces/ecpg/preproc/.deps
? src/interfaces/libpgeasy/.deps
? src/interfaces/libpq/.deps
? src/pl/plpgsql/src/.deps
? src/test/regress/expected/drop.out
? src/test/regress/sql/.alter_table.sql.swo
? src/test/regress/sql/.alter_table.sql.swp
Index: doc/src/sgml/catalogs.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/catalogs.sgml,v
retrieving revision 2.43
diff -c -r2.43 catalogs.sgml
*** doc/src/sgml/catalogs.sgml	2002/04/21 00:26:42	2.43
--- doc/src/sgml/catalogs.sgml	2002/06/15 16:37:46
***************
*** 72,82 ****
--- 72,92 ----
       </row>
  
       <row>
+       <entry>pg_constraint</entry>
+       <entry>check constraints, unique / primary key constraints, foreign key constraints</entry>
+      </row>
+ 
+      <row>
        <entry>pg_database</entry>
        <entry>databases within this database cluster</entry>
       </row>
  
       <row>
+       <entry>pg_depend</entry>
+       <entry>dependencies between database objects</entry>
+      </row>
+ 
+      <row>
        <entry>pg_description</entry>
        <entry>descriptions or comments on database objects</entry>
       </row>
***************
*** 132,142 ****
       </row>
  
       <row>
-       <entry>pg_relcheck</entry>
-       <entry>check constraints</entry>
-      </row>
- 
-      <row>
        <entry>pg_rewrite</entry>
        <entry>query rewriter rules</entry>
       </row>
--- 142,147 ----
***************
*** 680,686 ****
        <entry></entry>
        <entry>
         Number of check constraints on the table; see
!        <structname>pg_relcheck</structname> catalog
        </entry>
       </row>
  
--- 685,691 ----
        <entry></entry>
        <entry>
         Number of check constraints on the table; see
!        <structname>pg_constraint</structname> catalog
        </entry>
       </row>
  
***************
*** 764,770 ****
--- 769,908 ----
    </table>
   </sect1>
  
+  <sect1 id="catalog-pg-constraint">
+   <title>pg_constraint</title>
+ 
+   <para>
+    This system catalog stores CHECK, PRIMARY KEY, UNIQUE, and FOREIGN KEY
+    constraints on tables.  (Column
+    constraints are not treated specially.  Every column constraint is
+    equivalent to some table constraint.)  See under <command>CREATE
+    TABLE</command> for more information.
+    <note>
+      NOT NULL Constraints are handled by the <link linkend="catalog-pg-attribute">pg_attribute</link> table.
+    </note>
+   </para>
+ 
+   <table>
+    <title>pg_constraint Columns</title>
+ 
+    <tgroup cols=4>
+     <thead>
+      <row>
+       <entry>Name</entry>
+       <entry>Type</entry>
+       <entry>References</entry>
+       <entry>Description</entry>
+      </row>
+     </thead>
+ 
+     <tbody>
+      <row>
+       <entry>conrelid</entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_class.oid</entry>
+       <entry>The table this constraint is on</entry>
+      </row>
+ 
+      <row>
+       <entry>conname</entry>
+       <entry><type>name</type></entry>
+       <entry></entry>
+       <entry>Constraint name</entry>
+      </row>
+ 
+      <row>
+       <entry>contype</entry>
+       <entry><type>char</type></entry>
+       <entry></entry>
+       <entry>
+         'u' = unique constraint, 'p' = primary key, 'f' = foreign key constraint,
+         'c' = check constraint
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>condeferrable</entry>
+       <entry><type>boolean</type></entry>
+       <entry></entry>
+       <entry>Is the constraint is deferrable?</entry>
+      </row>
+ 
+      <row>
+       <entry>condeferred</entry>
+       <entry><type>boolean</type></entry>
+       <entry></entry>
+       <entry>Is the constraint deferred by default?</entry>
+      </row>
+ 
+      <row>
+       <entry>conkey</entry>
+       <entry><type>smallint[]</type></entry>
+       <entry>pg_attribute.attnum</entry>
+       <entry>List of columns to which the constraint is applied</entry>
+      </row>
+ 
+      <row>
+       <entry>confrelid</entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_class.oid</entry>
+       <entry>The table to which the foreign key refers to</entry>
+      </row>
+ 
+      <row>
+       <entry>confkey</entry>
+       <entry><type>smallint[]</type></entry>
+       <entry>pg_attribute.attnum</entry>
+       <entry>List of columns which the foreign key constraint refers to</entry>
+      </row>
+ 
+      <row>
+       <entry>confupdtype</entry>
+       <entry><type>char</type></entry>
+       <entry></entry>
+       <entry>Foreign key update type</entry>
+      </row>
+ 
+      <row>
+       <entry>confdeltype</entry>
+       <entry><type>char</type></entry>
+       <entry></entry>
+       <entry>Foreign key deletion type</entry>
+      </row>
  
+      <row>
+       <entry>confmatchtype</entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_class.oid</entry>
+       <entry>Foreign key match type.  </entry>
+      </row>
+ 
+      <row>
+       <entry>conbin</entry>
+       <entry><type>text</type></entry>
+       <entry></entry>
+       <entry>An internal representation of the check constraint expression</entry>
+      </row>
+ 
+      <row>
+       <entry>consrc</entry>
+       <entry><type>text</type></entry>
+       <entry></entry>
+       <entry>A human-readable representation of the check constraint expression</entry>
+      </row>
+     </tbody>
+    </tgroup>
+   </table>
+ 
+   <note>
+    <para>
+     <structname>pg_class</structname>.<structfield>relchecks</structfield>
+     needs to match up with the entries in this table.
+    </para>
+   </note>
+ 
+  </sect1>
+ 
   <sect1 id="catalog-pg-database">
    <title>pg_database</title>
  
***************
*** 903,908 ****
--- 1041,1133 ----
   </sect1>
  
  
+  <sect1 id="catalog-pg-depend">
+   <title>pg_depend</title>
+ 
+   <para>
+    The pg_depend table stores the dependency tree between database
+    objects which enables RESTRICT and CASCADE on <command>DROP</command> statements to
+    function properly.
+   </para>
+ 
+   <table>
+    <title>pg_depend Columns</title>
+ 
+    <tgroup cols=4>
+     <thead>
+      <row>
+       <entry>Name</entry>
+       <entry>Type</entry>
+       <entry>References</entry>
+       <entry>Description</entry>
+      </row>
+     </thead>
+ 
+     <tbody>
+      <row>
+       <entry>classid</entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_class.oid</entry>
+       <entry>The oid of the system catalog this depender is in.</entry>
+      </row>
+ 
+      <row>
+       <entry>objid</entry>
+       <entry><type>oid</type></entry>
+       <entry>any oid attribute</entry>
+       <entry>The oid of the object this depender pertains to</entry>
+      </row>
+ 
+      <row>
+       <entry>objsubid</entry>
+       <entry><type>integer</type></entry>
+       <entry></entry>
+       <entry>For a dependency on a table attribute, this is the attribute's
+        column number (the objid and classid refer to the table itself).
+        For all other object types, this field is presently zero.
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>depclassid</entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_class.oid</entry>
+       <entry>The oid of the system catalog this dependee is in.</entry>
+      </row>
+ 
+      <row>
+       <entry>depobjid</entry>
+       <entry><type>oid</type></entry>
+       <entry>any oid attribute</entry>
+       <entry>The oid of the object this dependee pertains to</entry>
+      </row>
+ 
+      <row>
+       <entry>depobjsubid</entry>
+       <entry><type>integer</type></entry>
+       <entry></entry>
+       <entry>For a dependee of a table attribute, this is the attribute's
+        column number (the objid and classid refer to the table itself).
+        For all other object types, this field is presently zero.
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>alwayscascade</entry>
+       <entry><type>boolean</type></entry>
+       <entry></entry>
+       <entry>For implicit dependencies which should ignore the RESTRICT keyword
+         and be cascaded to anyway. A table to its complex type, or a primary key 
+         constraint to the index which enforces the uniqueness portion</entry>
+      </row>
+ 
+     </tbody>
+    </tgroup>
+   </table>
+ 
+  </sect1>
+ 
+ 
   <sect1 id="catalog-pg-description">
    <title>pg_description</title>
  
***************
*** 1853,1924 ****
    </para>
  
   </sect1>
- 
- 
-  <sect1 id="catalog-pg-relcheck">
-   <title>pg_relcheck</title>
- 
-   <para>
-    This system catalog stores CHECK constraints on tables.  (Column
-    constraints are not treated specially.  Every column constraint is
-    equivalent to some table constraint.)  See under <command>CREATE
-    TABLE</command> for more information.
-   </para>
- 
-   <table>
-    <title>pg_relcheck Columns</title>
- 
-    <tgroup cols=4>
-     <thead>
-      <row>
-       <entry>Name</entry>
-       <entry>Type</entry>
-       <entry>References</entry>
-       <entry>Description</entry>
-      </row>
-     </thead>
- 
-     <tbody>
-      <row>
-       <entry>rcrelid</entry>
-       <entry><type>oid</type></entry>
-       <entry>pg_class.oid</entry>
-       <entry>The table this check constraint is on</entry>
-      </row>
- 
-      <row>
-       <entry>rcname</entry>
-       <entry><type>name</type></entry>
-       <entry></entry>
-       <entry>Constraint name</entry>
-      </row>
- 
-      <row>
-       <entry>rcbin</entry>
-       <entry><type>text</type></entry>
-       <entry></entry>
-       <entry>An internal representation of the constraint expression</entry>
-      </row>
- 
-      <row>
-       <entry>rcsrc</entry>
-       <entry><type>text</type></entry>
-       <entry></entry>
-       <entry>A human-readable representation of the constraint expression</entry>
-      </row>
-     </tbody>
-    </tgroup>
-   </table>
- 
-   <note>
-    <para>
-     <structname>pg_class</structname>.<structfield>relchecks</structfield>
-     needs to match up with the entries in this table.
-    </para>
-   </note>
- 
-  </sect1>
- 
  
   <sect1 id="catalog-pg-rewrite">
    <title>pg_rewrite</title>
--- 2078,2083 ----
Index: doc/src/sgml/ref/comment.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/comment.sgml,v
retrieving revision 1.19
diff -c -r1.19 comment.sgml
*** doc/src/sgml/ref/comment.sgml	2002/05/13 17:45:30	1.19
--- doc/src/sgml/ref/comment.sgml	2002/06/15 16:37:46
***************
*** 26,31 ****
--- 26,32 ----
    TABLE <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">table_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
    AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> (<replaceable class="PARAMETER">agg_type</replaceable>) |
+   CONSTRAINT <replaceable class="PARAMETER">constraint_name</replaceable> ON <replaceable class="PARAMETER">table_name</replaceable> |
    DATABASE <replaceable class="PARAMETER">object_name</replaceable> |
    DOMAIN <replaceable class="PARAMETER">object_name</replaceable> |
    FUNCTION <replaceable class="PARAMETER">func_name</replaceable> (<replaceable class="PARAMETER">arg1_type</replaceable>, <replaceable class="PARAMETER">arg2_type</replaceable>, ...) |
Index: doc/src/sgml/ref/drop_aggregate.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_aggregate.sgml,v
retrieving revision 1.18
diff -c -r1.18 drop_aggregate.sgml
*** doc/src/sgml/ref/drop_aggregate.sgml	2002/05/18 15:44:47	1.18
--- doc/src/sgml/ref/drop_aggregate.sgml	2002/06/15 16:37:46
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP AGGREGATE <replaceable class="PARAMETER">name</replaceable> ( <replaceable class="PARAMETER">type</replaceable> )
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPAGGREGATE-1">
--- 21,27 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP AGGREGATE <replaceable class="PARAMETER">name</replaceable> ( <replaceable class="PARAMETER">type</replaceable> ) [ CASCADE | RESTRICT ]
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPAGGREGATE-1">
***************
*** 51,56 ****
--- 51,76 ----
  	further information about data types.)
  	<comment>This should become a cross-reference rather than a
  	 hard-coded chapter number</comment>
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only an aggregate with no dependent database objects
+         can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing database objects
+         will also be dropped.
         </para>
        </listitem>
       </varlistentry>
Index: doc/src/sgml/ref/drop_function.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_function.sgml,v
retrieving revision 1.20
diff -c -r1.20 drop_function.sgml
*** doc/src/sgml/ref/drop_function.sgml	2002/05/18 15:44:47	1.20
--- doc/src/sgml/ref/drop_function.sgml	2002/06/15 16:37:46
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP FUNCTION <replaceable class="parameter">name</replaceable> ( [ <replaceable class="parameter">type</replaceable> [, ...] ] )
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPFUNCTION-1">
--- 21,27 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP FUNCTION <replaceable class="parameter">name</replaceable> ( [ <replaceable class="parameter">type</replaceable> [, ...] ] ) [ CASCADE | RESTRICT ]
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPFUNCTION-1">
***************
*** 46,51 ****
--- 46,71 ----
        <listitem>
         <para>
  	The type of a parameter of the function.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a function with no dependent types or operators
+         can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing types or operators
+         will also be dropped.
         </para>
        </listitem>
       </varlistentry>
Index: doc/src/sgml/ref/drop_index.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_index.sgml,v
retrieving revision 1.15
diff -c -r1.15 drop_index.sgml
*** doc/src/sgml/ref/drop_index.sgml	2002/05/18 15:44:47	1.15
--- doc/src/sgml/ref/drop_index.sgml	2002/06/15 16:37:46
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP INDEX <replaceable class="PARAMETER">index_name</replaceable> [, ...]
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPINDEX-1">
--- 21,27 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP INDEX <replaceable class="PARAMETER">index_name</replaceable> [, ...] [ CASCADE | RESTRICT ]
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPINDEX-1">
Index: doc/src/sgml/ref/drop_language.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_language.sgml,v
retrieving revision 1.14
diff -c -r1.14 drop_language.sgml
*** doc/src/sgml/ref/drop_language.sgml	2002/05/18 15:44:47	1.14
--- doc/src/sgml/ref/drop_language.sgml	2002/06/15 16:37:46
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP [ PROCEDURAL ] LANGUAGE <replaceable class="PARAMETER">name</replaceable>
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPLANGUAGE-1">
--- 21,27 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP [ PROCEDURAL ] LANGUAGE <replaceable class="PARAMETER">name</replaceable> [ CASCADE | RESTRICT ]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPLANGUAGE-1">
***************
*** 44,49 ****
--- 44,70 ----
        </listitem>
       </varlistentry>
      </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a language with no dependent functions
+         can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing functions
+         will also be dropped.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+ 
     </para>
    </refsect2>
    
Index: doc/src/sgml/ref/drop_operator.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_operator.sgml,v
retrieving revision 1.16
diff -c -r1.16 drop_operator.sgml
*** doc/src/sgml/ref/drop_operator.sgml	2002/05/18 15:44:47	1.16
--- doc/src/sgml/ref/drop_operator.sgml	2002/06/15 16:37:47
***************
*** 22,28 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP OPERATOR <replaceable class="PARAMETER">id</replaceable> ( <replaceable class="PARAMETER">lefttype</replaceable> | NONE , <replaceable class="PARAMETER">righttype</replaceable> | NONE )
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPOPERATOR-1">
--- 22,28 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP OPERATOR <replaceable class="PARAMETER">id</replaceable> ( <replaceable class="PARAMETER">lefttype</replaceable> | NONE , <replaceable class="PARAMETER">righttype</replaceable> | NONE ) [ CASCADE | RESTRICT ]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPOPERATOR-1">
Index: doc/src/sgml/ref/drop_rule.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_rule.sgml,v
retrieving revision 1.15
diff -c -r1.15 drop_rule.sgml
*** doc/src/sgml/ref/drop_rule.sgml	2002/05/18 15:44:47	1.15
--- doc/src/sgml/ref/drop_rule.sgml	2002/06/15 16:37:51
***************
*** 21,27 ****
     <date>1998-09-22</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP RULE <replaceable class="PARAMETER">name</replaceable> ON <replaceable class="PARAMETER">relation</replaceable>
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPRULE-1">
--- 21,27 ----
     <date>1998-09-22</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP RULE <replaceable class="PARAMETER">name</replaceable> ON <replaceable class="PARAMETER">relation</replaceable> [ CASCADE | RESTRICT ]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPRULE-1">
***************
*** 51,56 ****
--- 51,77 ----
        </listitem>
       </varlistentry>
      </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a rule with no dependent database objects
+         can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing database objects
+         will also be dropped.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+ 
     </para>
    </refsect2>
  
Index: doc/src/sgml/ref/drop_sequence.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_sequence.sgml,v
retrieving revision 1.14
diff -c -r1.14 drop_sequence.sgml
*** doc/src/sgml/ref/drop_sequence.sgml	2002/05/18 15:44:47	1.14
--- doc/src/sgml/ref/drop_sequence.sgml	2002/06/15 16:37:51
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP SEQUENCE <replaceable class="PARAMETER">name</replaceable> [, ...]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPSEQUENCE-1">
--- 21,28 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP SEQUENCE <replaceable class="PARAMETER">name</replaceable> [, ...] [ CASCADE | RESTRICT ]
! 
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPSEQUENCE-1">
***************
*** 76,81 ****
--- 77,102 ----
        </listitem>
       </varlistentry>
      </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a sequence dependent tables can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing tables
+         will also be dropped.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+ 
     </para>
    </refsect2>
   </refsynopsisdiv>
Index: doc/src/sgml/ref/drop_table.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_table.sgml,v
retrieving revision 1.15
diff -c -r1.15 drop_table.sgml
*** doc/src/sgml/ref/drop_table.sgml	2002/05/18 15:44:47	1.15
--- doc/src/sgml/ref/drop_table.sgml	2002/06/15 16:37:51
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP TABLE <replaceable class="PARAMETER">name</replaceable> [, ...]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPTABLE-1">
--- 21,28 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP TABLE <replaceable class="PARAMETER">name</replaceable> [, ...] [ CASCADE | RESTRICT ]
! 
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPTABLE-1">
***************
*** 42,47 ****
--- 43,73 ----
        </listitem>
       </varlistentry>
      </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a table with no dependent views or
+         integrity constraints can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing views or integrity constraints
+         will also be dropped.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+    </refsect2>
+  </refsect1>
+ </refentry>
+ 
+ 
     </para>
    </refsect2>
  
***************
*** 135,182 ****
     Compatibility
    </title>
    
-   <refsect2 id="R2-SQL-DROPTABLE-4">
-    <refsect2info>
-     <date>1998-09-22</date>
-    </refsect2info>
-    <title>
-     SQL92
-    </title>
-    <para>
-     SQL92 specifies some additional capabilities for DROP TABLE:
-    </para>
-    <synopsis>
- DROP TABLE <replaceable class="parameter">table</replaceable> { RESTRICT | CASCADE }
-    </synopsis>
-    <variablelist>
-     <varlistentry>
-      <term>RESTRICT</term>
-      <listitem>
-       <para>
-        Ensures that only a table with no dependent views or
-        integrity constraints can be destroyed.
-       </para>
-      </listitem>
-     </varlistentry>
-     <varlistentry>
-      <term>CASCADE</term>
-      <listitem>
-       <para>
-        Any referencing views or integrity constraints
-        will also be dropped.
-       </para>
-      </listitem>
-     </varlistentry>
-    </variablelist>
-     <tip>
-     <para>
-      At present, to remove a referencing view you must drop
-      it explicitly.
-     </para>
-    </tip>
-    </refsect2>
-  </refsect1>
- </refentry>
  
  <!-- Keep this comment at the end of the file
  Local variables:
--- 161,166 ----
Index: doc/src/sgml/ref/drop_trigger.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_trigger.sgml,v
retrieving revision 1.12
diff -c -r1.12 drop_trigger.sgml
*** doc/src/sgml/ref/drop_trigger.sgml	2002/05/18 15:44:47	1.12
--- doc/src/sgml/ref/drop_trigger.sgml	2002/06/15 16:37:51
***************
*** 21,27 ****
     <date>1998-09-22</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP TRIGGER <replaceable class="PARAMETER">name</replaceable> ON <replaceable class="PARAMETER">table</replaceable>
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPTRIGGER-1">
--- 21,27 ----
     <date>1998-09-22</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP TRIGGER <replaceable class="PARAMETER">name</replaceable> ON <replaceable class="PARAMETER">table</replaceable> [ CASCADE | RESTRICT ]
    </synopsis>
  
    <refsect2 id="R2-SQL-DROPTRIGGER-1">
***************
*** 47,52 ****
--- 47,72 ----
        <listitem>
         <para>
  	The name (optionally schema-qualified) of a table.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a trigger with no dependent database objects
+         can be destroyed.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing system objects
+         will also be dropped.
         </para>
        </listitem>
       </varlistentry>
Index: doc/src/sgml/ref/drop_type.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_type.sgml,v
retrieving revision 1.17
diff -c -r1.17 drop_type.sgml
*** doc/src/sgml/ref/drop_type.sgml	2002/05/18 15:44:47	1.17
--- doc/src/sgml/ref/drop_type.sgml	2002/06/15 16:37:51
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP TYPE <replaceable class="PARAMETER">typename</replaceable> [, ...]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPTYPE-1">
--- 21,28 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP TYPE <replaceable class="PARAMETER">typename</replaceable> [, ...] [ CASCADE | RESTRICT ]
! 
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPTYPE-1">
***************
*** 75,80 ****
--- 76,102 ----
        </listitem>
       </varlistentry>
      </variablelist>
+     <variablelist>
+      <varlistentry>
+       <term>RESTRICT</term>
+       <listitem>
+        <para>
+         Ensures that only a type which is not used in tables, views, domains, functions, etc. 
+         will be allowed to be dropped.
+        </para>
+       </listitem>
+      </varlistentry>
+      <varlistentry>
+       <term>CASCADE</term>
+       <listitem>
+        <para>
+         Any referencing tables, views, domains, functions, etc.
+         will also be dropped.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+ 
     </para>
    </refsect2>
   </refsynopsisdiv>
***************
*** 131,149 ****
  
   <refsect1 id="SQL-DROPTYPE-compatibility">
    <title>Compatibility</title>
- 
-   <para>
-    A <command>DROP TYPE</command> statement exists in SQL99.  As with
-    most other <quote>drop</quote> commands, <command>DROP
-    TYPE</command> in SQL99 requires a <quote>drop behavior</quote>
-    clause to select between dropping all dependent objects or refusing
-    to drop if dependent objects exist:
- <synopsis>
- DROP TYPE <replaceable>name</replaceable> { CASCADE | RESTRICT }
- </synopsis>
-    <productname>PostgreSQL</productname> currently ignores
-    dependencies altogether.
-   </para>
  
    <para>
     Note that the <command>CREATE TYPE</command> command and the data
--- 153,158 ----
